!   API Kassa "      "
!   17.12.2024 .
! ------------------------------------------------
!  :  https://forum.clarionlife.net
! LibCurl & cJSON: https://github.com/mikeduglas
!  Kassa:   https://yookassa.ru
! ------------------------------------------------

  Include('YKassa.equ'),Once   ! 
  Include('libcurl.inc'),Once  ! -> Include('DynStr.inc'),Once
  Include('cJSON.inc'),Once    !  ! : true/false -  lowercase !
           
  ! ---  

  Map
    Module('YKassa')
      YKassa::Message(String sText,Byte bAddMode = 0)   ! 
      YKassa::AskMe(String sText),Bool                  !   
      YKassa::View(*Queue qList)                        !    
      YKassa::GetGUID(),String                          !  GUID
      YKassa::OpenWebPage(String xLink)                 !  WEB 
      YKassa::SetFileISO(),String                       !   JSON     / 
                                                        !    1199 " " 
      YKassa::Calc1199(Byte bTaxRate = 255,Bool bNoNDS = False),Byte
                                                        !    
      YKassa::StatusRus(Byte bProcessing,*YKassa:G_Data gData),String
      YKassa::Calc2108(Long lOKEI,String sUnit),Byte    !    2108 "  "      
      YKassa::Nick2108(Long lOKEI,String sUnit),String  !      2108 "  "      
      YKassa::NormPhone(String sPhone),String           !      ITU-T E.164
                                                        !    1212 "  "
      YKassa::Nick1212(Byte bObject,Bool bTestShop = False),String 
      YKassa::Nick1214(Byte bMethod = 0),String         !    1214 "   "       
                                                        !   /  ( 2005-08-15T15:52:01Z ) 
      YKassa::FormatDate(<Long inDate>,<Long inTime>),String
    end
    Module('Windows API')
      YKassa::Sleep(Long),Pascal,Name('Sleep')
    end    
  end

  ! ---  ( !   REST  -  !)
  
!    TYPE / VARIABLE
! L / l  -> LONG
! B / b  -> BYTE (BOOL)    
! R / r  -> REAL
! D / d  -> DECIMAL
! S / s  -> STRING
! C / c  -> CSTRING
! G / g  -> GROUP
! Q / q  -> QUEUE
! I / i  -> IDynStr
! J / j  -> cJSON
! * Text ->   

!!!                      
YKassa:G_amount     Group,Type
value                 CString(21)          !     
currency              CString( 4)          !      ISO-4217. : RUB.
                    end

!!!  
YKassa:G_Data      Group,Type
Idempotence          CString(37)           !  
ID                   CString(41)           ! ID (  - 39  !)
Status               CString(21)           !  
Created              CString(25)           !  
                                           ! 
Amount               Group(YKassa:G_amount).
                                           
fiscal_document_number CString(21)         !   ( ) 
tax_system_code        Byte                ! 1055   
                   end

!!!  Kassa
YKassa:G_Oper      Group,Type
Processing           Byte(0)               !  
Payment              Group(YKassa:G_Data)  ! 1. 
URL                    CString(2049)       ! +    
                     end
Refund               Group(YKassa:G_Data). ! 2. 
                    end
                   
!!!   ,     
YKassa:G_metadata   Group,Type
name                  String( 32)          !   
value                 String(512)          !   (   UTF-8)
                    end                    
                    
YKassa:G_Settlements Group                 !    
type                  CString(21)          !  .  : payout   
                                           !   
amount                Group(YKassa:G_Amount).
                    end

!!!   ,                        
YKassa:G_deal       Group,Type
id                    CString(41)          !  
                                           !    
settlements           Group(YKassa:G_Settlements),Dim(5).
                    end
                    
!!!            
YKassa:G_transfers  Group
account_id            CString(41)          !  ,      
                                           ! ,    
amount                Group(YKassa:G_amount).   
status                CString(41)          !     
                                           !      ,       
platform_fee_amount   Group(YKassa:G_amount).
description           CString(129)         !   (  128 ),       Kassa
                                           !   ,     
metadata              Group(YKassa:G_metadata),Dim(16).
                    end
                    
!!!  
YKassa:G_Industry   Group,Type
federal_id            CString(4)           !      (  54   1262) 
document_date         CString(11)          !    (  54   1263).    ISO 8601
document_number       CString(65)          !        (  54   1264)
value                 CString(256)         !    (  54   1265)
                    end

!!!  
YKassa:G_Operational Group,Type            
operation_id            Byte               ! 1271  .   0  255
value                   CString(129)       ! 1272  
created_at              CString(25)        ! 1273   
                    end
                    
!!!   
YKassa:Q_Item       Queue,Type
description           CString(129)         ! 1030  
                                           ! 1079   
amount                Group(YKassa:G_amount).
vat_code              Byte                 ! 1199  
quantity              Decimal(11,3)        ! 1023  
measure               CString(21)          ! 2108    
mark_quantity         Group                ! 1291    
numerator               Long               ! 1293         
denominator             Long               ! 1294          
                      end
payment_subject       CString(41)          ! 1212    (   )
payment_mode          CString(41)          ! 1214     (      )
country_of_origin_code      CString(11)    ! 1230          
customs_declaration_number  CString(33)    ! 1231   
excise                CString(21)          ! 1229      .      2   .
product_code          CString(99)          ! 1162  
mark_code_info        Group                ! 1163  
mark_code_raw           CString(256)       ! 2000     ,      
unknown                 CString(33)        ! 1300   
ean_8                   CString(9)         ! 1301     EAN-8
ean_13                  CString(14)        ! 1302     EAN-13
itf_14                  CString(15)        ! 1303     ITF-14
gs_10                   CString(39)        ! 1304     GS1.0
gs_1m                   CString(201)       ! 1305     GS1.M
short                   CString(39)        ! 1306       
fur                     CString(21)        ! 1307 -   
egais_20                CString(34)        ! 1308     -2.0 
egais_30                CString(15)        ! 1309     -3.0 
                      end
mark_mode             CString(2)           ! 2102     ->  '0'
                      
                                           ! 1260   
payment_subject_industry_details Group(YKassa:G_Industry),Dim(3).
                    end
                    
!YKassa:CountItems   Equate(20)             !    ( 54- <= 100 ,    <= 6)

!!!                        
YKassa:G_ReqReceipt Group,Type
customer              Group                !   
full_name               CString(257)       !     ,        /  
inn                     CString(13)        !   (10  12 )
email                   CString(81)        !      
phone                   CString(15)        !      
                      end
                                           
items                 &YKassa:Q_Item       !    
tax_system_code       Byte                 ! 1055   
                                           ! 1261   
receipt_industry_details    Group(YKassa:G_Industry),Dim(3).
                                           ! 1270   
receipt_operational_details Group(YKassa:G_Operational).
                    end
                    
!!!  
YKassa:G_ReqPayment Group,Type
                                           !  
amount                Group(YKassa:G_Amount).
description           CString(129)         !   (  128 ),      Kassa,     .
                                           !    
receipt               Group(YKassa:G_ReqReceipt).
recipient             Group                !  
gateway_id              CString(21)        !   
                      end
payment_token         CString(81)          !     ,    Checkout.js   SDK.
payment_method_id     CString(41)          !    .

payment_method_data   Group                ! *      
type                    CString(21)        !    
phone                   CString(15)        ! ,      (ITU-T E.164,  79000000000)
card                    Group              ! *    (,         )
                        end
payment_purpose         CString(211)       !   
vat_data                Group              !       ()
type                      CString(21)      !    
                                           !    
amount                    Group(YKassa:G_amount).
rate                      CString(11)      !   ( ) 
                        end
                      end                     
                      
confirmation          Group                ! ,        
type                    CString(21)        !   
enforce                 Bool(False)        !        3-D Secure.
locale                  CString( 6)        !  ,   ,      
return_url              CString(2049)      ! URL,           -
                      end                      

save_payment_method   Bool(False)          !      
capture               Bool(False)          !    
client_ip             CString(41)          ! IPv4  IPv6- .   ,  IP- TCP-
                                           !   ,     
metadata              Group(YKassa:G_Metadata),Dim(16).
airline               Group                ! *      .      .
                      end 
                                           !            
transfers             Group(YKassa:G_transfers),Dim(5).
                                           !   ,     .  ,     
deal                  Group(YKassa:G_Deal).
                     
merchant_customer_id  CString(201)         !     ,      .

receiver              Group                !       ,      
type                    CString(21)        !   
                                           ! -     (type = 'bank_account')       
account_number          CString(21)        !   
bic                     CString(10)        !    () ,    
                                           ! -   (type = 'mobile_balance')
phone                   CString(16)        !    .    ITU-T E.164.                                    
                                           ! -   (type = 'digital_wallet') 
!account_number         CString(21)        !     
                      end 
                    end                    ! YKassa:G_Request
YKassa:J_ReqPayment Equate('{{"name":["enforce","save_payment_method","capture"],"IsBool":true}')

!!!   
YKassa:G_ReqRefund  Group,Type
payment_id            CString(37)          !    Kassa
                                           ! ,    
amount                Group(YKassa:G_Amount).
description           CString(129)         !   (  128 ),      Kassa,     .
                                           !    
receipt               Group(YKassa:G_ReqReceipt).
sources               Group,Dim(2)         ! *   ,           
                      end
deal                  Group,Dim(2)         ! *   ,                  
                      end
refund_method_data    Group                ! *  .    ,      
type                    CString(21)        !   
                      end
                    end
                   
!!!                     
YKassa:G_Payment    Group,Type
id                    CString(37)          !    Kassa
status                CString(21)          !  
                                           !  
amount                Group(YKassa:G_Amount).
                                           !  ,   ,   amount    Kassa.
income_amount         Group(YKassa:G_Amount).
description           CString(128)         !  ,       Kassa,     .
recipient             Group                !  .
account_id              CString(21)        !    Kassa.
gateway_id              CString(21)        !  .         .
                      end
                     
payment_method        Group                !   ,      
type                    CString(21)        !   
id                      CString(37)        !   
saved                   Bool               !         
title                   CString(129)       !   
payer_bank_details      Group              !  ,    
bank_id                   CString(13)      !        ()
bic                       CString(10)      !    ()    
                        end
sbp_operation_id        CString(81)        !     ()
                      end 
captured_at           CString(25)          !    
created_at            CString(25)          !   
expires_at            CString(25)          ! ,         

confirmation          Group                !    . ,      
type                    CString(21)        !   
confirmation_token      CString(41)        !      Kassa
confirmation_url        CString(513)       !    ,     
confirmation_data       CString(513)       !    QR-
enforce                 Bool               !        3-D Secure
return_url              CString(2049)      ! URL,           -
                      end
test                  Bool                 !    
                                           ! ,   . ,       
refunded_amount       Group(YKassa:G_Amount).
paid                  Bool                 !   
refundable            Bool                 !     API
receipt_registration  CString(21)          !   
                                           !   ,     
metadata              Group(YKassa:G_Metadata),Dim(16).
cancellation_details  Group                !    canceled:       
party                   CString(21)        !   ,      
reason                  CString(41)        !   .     
                      end 
                     
authorization_details Group                !        
rrn                     CString(21)        ! Retrieval Reference Number       .
auth_code               CString(11)        !  .      .
three_d_secure          Group              !       3?D Secure   .
applied                   Bool             !        3?D Secure.
                        end
                      end
                                           !                                   
transfers             Group(YKassa:G_transfers),Dim(5).
                                           !   ,                          
deal                  Group(YKassa:G_Deal).
                     
merchant_customer_id  CString(201)         !     ,       
invoice_details       Group                !    ,     
id                      CString(41)        !    
                      end
                    end                    ! YKassa:G_Payment
YKassa:J_Payment    Equate('{{"name":["enforce","saved","test","paid","refundable","applied"],"IsBool":true}')

!!!  
YKassa:G_Refund     Group,Type
id                    CString(37)          !     Kassa
payment_id            CString(37)          !    Kassa
status                CString(21)          !   
cancellation_details  Group                !    canceled:       
party                   CString(41)        !   ,     
reason                  CString(41)        !    
                      end
receipt_registration  CString(21)          !   
created_at            CString(25)          !   
                                           !  
amount                Group(YKassa:G_Amount).
description           CString(129)         !     
sources               Group,Dim(2)         ! *   ,           
                      end
deal                  Group                ! *   ,     
                      end                      
refund_method_data    Group                ! *  .    ,      
type                    CString(21)        !   
                      end                      
                    end
                    
!!!  
YKassa:G_Receipt    Group,Type
id                    CString(37)          !    Kassa
type                  CString(21)          !    -:  (payment)    (refund)
payment_id            CString(37)          !  ,     .
refund_id             CString(37)          !  ,     .    .
status                CString(21)          !       -

fiscal_document_number CString(21)         !   
fiscal_storage_number CString(21)          !      
fiscal_attribute      CString(21)          !   
registered_at         CString(25)          !        
fiscal_provider_id    CString(121)         !    -

items                 &YKassa:Q_Item       !    
                                           !   
settlements           Group(YKassa:G_Settlements),Dim(5).

on_behalf_of          CString(37)          !  ,       
tax_system_code       Byte                 ! 1055   
                                           ! 1261   
receipt_industry_details    Group(YKassa:G_Industry),Dim(3).
                                           ! 1270   
receipt_operational_details Group(YKassa:G_Operational).
                    end

!!!    / 
YKassa:G_AskMe      Group
account_id            CString(37)          !    
status                CString(21)          !    
test                  Bool                 !     
fiscalization         Group                !       
enabled                 Bool               !      
provider                CString(21)        !  Kassa,      
                      end
payment_methods       CString(41),Dim(20)  !   ,  
itn                   CString(21)          !   ( 1  20 )
payout_methods        CString(21),Dim(9)   !    ,  
name                  CString(21)          !  ,      Kassa
                                           !    
payout_balance        Group(YKassa:G_amount).
                    end
YKassa:J_AskMe      Equate('{{"name":["test","enabled"],"IsBool":true}')

!!!       ,        
YKassa:Q_Cart       Queue,Type
description           CString(129)         !    .           
                                           !     .         
price                 Group(YKassa:G_Amount).
                                           !      
discount_price        Group(YKassa:G_Amount).
quantity              Decimal(13,3)        !  .      .
                    end

!!!   
YKassa:G_ReqInvoice Group,Type
payment_data          Group                !       
                                           !  .    
amount                  Group(YKassa:G_Amount).
                                           !    
receipt                 Group(YKassa:G_ReqReceipt).
recipient               Group,Dim(2)       !  
gateway_id                CString(21)      !   
                        end
save_payment_method     Bool               !      
capture                 Bool               !    
client_ip               CString(41)        ! IPv4  IPv6- .   ,  IP- TCP-
description             CString(129)       !   (  128 )
                                           !   ,     
metadata                Group(YKassa:G_Metadata),Dim(16).
                      end
cart                  &YKassa:Q_Cart       !       ,        
delivery_method_data  Group                !       
type                    CString(21)        !     
                      end
expires_at            CString(25)          !       ,      
locale                CString(11)          !  ,   ,      
description           CString(129)         !   (  128 )
                                           !   ,     
metadata              Group(YKassa:G_Metadata),Dim(16).
                    end
YKassa:J_ReqInvoice Equate('{{"name":["save_payment_method","capture"],"IsBool":true}')                    
                    
!!!                      
YKassa:G_Invoice    Group,Type
id                    CString(40)          !    
status                CString(21)          !  
cart                  &YKassa:Q_Cart       !       ,        
delivery_method       Group                !      .       pending
type                    CString(21)        !     
url                     CString(2049)      ! URL  ,      
                      end
payment_details       Group                !      . ,    
id                      CString(37)        !    Kassa 
status                  CString(41)        !  
                      end
created_at            CString(25)          !       .   UTC     ISO 8601 
expires_at            CString(25)          !       ,       
description           CString(129)         !   
cancellation_details  Group                !    canceled:       
party                   CString(21)        !  ,      
reason                  CString(41)        !    
                      end
                                           !   ,     
metadata              Group(YKassa:G_metadata),Dim(16).                      
                    end
                    
!!!  API Kassa
YKassa             Class,Type,Module('YKassa.clw'),Link('YKassa.clw')
Curl                 &TCurlClass,Private   !   Curl
ResponseBuffer       &IDynStr,Private      !    

ShopID               CString(21),Private   ! ID 
SecretKey            CString(61),Private   !  

FlagInit             Bool(False)           !   
TestShop             Bool(False)           !   

DebugCodePage        Long(-1),Private      !       (  = -1)
                                           !     JSON   
UploadToFile         CString(File:MaxFileName)
InfoText             UShort(0)             !   

Construct            Procedure
Destruct             Procedure
Init                 Procedure(String sShopID,String sSecretKey,Long lDebugCodePage = -1),Bool,Proc

!!!     Curl  
SetTimeOut           Procedure(Long inTimeOut = 5)
!!!   Curl
SetHeaderCurl        Procedure(String sTypeRequest,<String sIdKey>),Bool,Proc,Private
!!!       Curl
CheckResponse        Procedure(*CurlCode xResult_,String xPlace_,Long lExceptionCode = -137137),Bool,Private
!!!    
ShowInfoText         Procedure(<String sText>),Private

!!!   
Debug                Procedure(String sFileName, String   sText,   Long lTextCodePage = CP_UTF8),Private
Debug                Procedure(String sFileName, *IDynStr iBuffer, Long lTextCodePage = CP_UTF8),Private
Debug                Procedure(String sFileName, *cJSON   jObject, Long lTextCodePage = CP_UTF8),Private

!!!    / 
AskMe                Procedure(*YKassa:G_AskMe gAskMe,Bool bDisplay = False),Bool,Proc

!!!  
PaymentCreate        Procedure(*YKassa:G_ReqPayment gReqPayment,*YKassa:G_Payment gPayment,*YKassa:G_Data gData),Bool,Proc
!!!    
RefundCreate         Procedure(*YKassa:G_ReqRefund  gReqRefund, *YKassa:G_Refund  gRefund, *YKassa:G_Data gData),Bool,Proc

!!!     
PaymentInfo          Procedure(*YKassa:G_Payment gPayment,*YKassa:G_Data gData),Bool
!!!   (    )
PaymentCancel        Procedure(*YKassa:G_Payment gPayment,*YKassa:G_Data gData),Bool,Proc

!!!   
RefundInfo           Procedure(*YKassa:G_Refund  gRefund, *YKassa:G_Data gData),Bool
!!!   
ReceiptInfo          Procedure(*YKassa:G_Data gData),Bool

!!!   
InvoiceCreate        Procedure(*YKassa:G_ReqInvoice gReqInvoice,*YKassa:G_Invoice gInvoice,*YKassa:G_Data gData),Bool,Proc
!!!   
InvoiceInfo          Procedure(*YKassa:G_Invoice gInvoice,*YKassa:G_Data gData),Bool

                   end